#include "arbol.h"

void arbol::Abuelo(int valor)
{
  if (raiz!=NULL)
    {
    raiz->abuelo(raiz,valor);
    }
}

void arbol::Actualizar()
{
  if (raiz!=NULL)
    {
      raiz->actualizar(raiz);
    }
}

void arbol::Altura(int num,int &cont)
{
  if(raiz!=NULL)
    {
      raiz->altura (raiz,num,cont);
    }
}


int arbol::InsertarRecursivo(int x)
{
  if (raiz!=NULL)
    {
      return(raiz->inserta(x));
    }
  else
    {
      raiz=new nudo(x);
      return(1);
    }
}

int arbol::BuscarRecursivo(int x)
{
  if (raiz!=NULL)
    {
      return(raiz->busca(x));
    }
  else
    {
      return(0);
    }
}

void arbol::BuscarMaximo(void (*f)(int))
{
  if (raiz!=NULL)
    {
    raiz->maximo(f);
    }
}

void arbol::BuscarMinimo(void (*f)(int))
{
  if (raiz!=NULL)
    {
      raiz->minimo(f);
    }
}


int arbol::BorrarRecursivo(int x)
{
  if (raiz!=NULL)
    {
    return(raiz->borra(x,raiz));
    }
  else
   {
     return(0);
   }
}

void arbol::Descendientes(int valor, int &contador)
{
  if(raiz!=NULL)
    {
      raiz->descendientes(raiz,valor,contador);
    }
}

void arbol::Descendientes_Hojas(int valor, int &contador)
{
  if(raiz!=NULL)
    {
      raiz->descendientes_hojas(raiz,valor,contador);
    }
}

void arbol::Liberar()
{
if(raiz!=NULL)
    {
    raiz->liberar(raiz);
    }
}

void arbol::Padre(int valor)
{
  if (raiz!=NULL)
    {
     raiz->padre(raiz,valor);
    }
}



void arbol::Profundidad (int num,int &cont)
{
  raiz->profundidad(raiz,num,cont);
}

void arbol::RecorridoPrefijo(void (*f)(int))
{
  if (raiz!=NULL)
    {
    raiz->recorreprefijo(f);
    }
}

void arbol::RecorridoPostfijo(void (*f)(int))
{
  if (raiz!=NULL)
    {
      raiz->recorrepostfijo(f);
    }
}

void arbol::RecorridoInfijo(void (*f)(int))
{
  if (raiz!=NULL)
    {
      raiz->recorreinfijo(f);
    }
}


void arbol::Terminales()
{
  raiz->terminales(raiz);
}

