#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

class arbol
{
  class nudo
    {
      int inf;			//campo informativo
      int desc;	//almacena el numero de descendientes
      int alt;		//altura
      int prof;		//profundidad
      nudo *hi;			//puntero a hijo izquierdo
      nudo *hd;			//puntero a hijo derecho
    public:
      nudo(int x)	//constructor, x es el campo informativo
	{	
	  inf=x;
	  hi=NULL;
	  hd=NULL;
	};
      ~nudo() 	//destructor
	     {
	       if (hi) 
		 delete hi;
	       if (hd)
		 delete hd;
	     };		     
      void recorre_descendientes(nudo * &p, int &contador);
      void recorre_descendientes_hojas(nudo * &p, int &contador);
      void recorre_altura(nudo * &p, int aux, int &contador);
      void recorreprefijo(void (*f)(int));
      void recorreinfijo(void (*f)(int));
      void recorrepostfijo(void (*f)(int));
      int inserta(int x);
      int busca(int x);
      int borra(int x,nudo * &p);
      int bor(nudo * &p);	//funcion auxiliar que se necesita para el borrado
      void liberar(nudo * &p);
      void maximo(void (*f)(int));
      void minimo(void (*f)(int));
      void descendientes(nudo *raiz, int valor, int &contador);
      void descendientes_hojas(nudo *raiz, int valor, int &contador);
      void altura (nudo *raiz,int num,int &cont);
      void profundidad (nudo *raiz,int num,int &cont);
      void abuelo(nudo *raiz, int valor);
      void padre(nudo *raiz, int valor);
      void primos(nudo *raiz,int num);
      void terminales(nudo *raiz);      
      void actualizar(nudo * &p);
//      int suma_elementos(nudo *raiz);
//      int elementos(nudo *raiz);
    };

  nudo *raiz;			//puntero que apunta a la raiz del arbol
 public:
  arbol()			//consturctor del arbol
    {
      raiz=NULL;
    };
  ~arbol () {if (raiz) delete raiz;}; 	//destructor
  int InsertarRecursivo(int x);
  int BuscarRecursivo(int x);
  int BorrarRecursivo(int x);
  void Liberar();
  void RecorridoPrefijo(void (*f)(int));
  void RecorridoInfijo(void (*f)(int));
  void RecorridoPostfijo(void (*f)(int));
  void BuscarMaximo(void (*f)(int));
  void BuscarMinimo(void (*f)(int));
  void Actualizar();
  void Descendientes(int valor, int &contador);
  void Descendientes_Hojas(int valor, int &contador);
  void Profundidad (int num,int &cont);
  void Altura (int num,int &cont);
  void Abuelo(int valor);
  void Padre(int valor);
  void Terminales();
//  float Media();
  //   nudo *padre(int valor);
  
  
};


   
