#include "arbol.h"

/* FUNCIONES VARIAS */
/* funcion utilizada para el acceso a funciones */
void imprime(int x)
{
  cout << x << ", ";
}

/* funcion utilizada para hacer pausas con el teclado en el menu */
void pausa()
{
  cout << "\nPresione intro para continuar";
    fflush(stdin);
    getc(stdin);
    getc(stdin);
}


/* Funcion Principal */

void main(void)
{
  arbol a;
  int x, opcion, encontrado, valor, contador=0;
  /* menu */
  do
    {
      
      system ("clear");
      cout << "\nM E N U\n";
      cout << "\n 1.- Insertar nodos recursivamente, por defecto";
      cout << "\n 2.- Buscar un nodo";
      cout << "\n 3.- Recorrido Prefijo";
      cout << "\n 4.- Recorrido Infijo";
      cout << "\n 5.- Recorrido Postfijo";
      cout << "\n 6.- Minimo del Arbol";
      cout << "\n 7.- Maximo del Arbol";
      cout << "\n 8.- Altura de un nodo";
      cout << "\n 9.- Profundidad de un nodo";
      cout << "\n10.- Numero de descendientes";
      cout << "\n11.- Numero de descendientes que son hojas";
      cout << "\n12.- Abuelo de un nodo";
      cout << "\n13.- Padre de un nodo";
      cout << "\n14.- Ver nodos terminales";
      cout << "\n15.- Actualizar campos";
      cout << "\n16.- Media de los nodos";
      /*******************************************
      cout << "\n11.- Primos de un nodo";
      cout << "\n12.- Nietos de un nodo";
      cout << "\n14.- Ver descendientes comunes\n";
      cout << "\n16.- Tio de un nodo\n";
      *********************************************/
      
      cout << "\n 0.- Salir\n";
      cin >> opcion;
      switch (opcion)
	{
	case 1: // inserccion ordenada
	  // se insertan por defecto
	  /*	    cout << "Introduzca un entero: ";
		    cin >> x;
		    while (x!=0)
		    {
		    a.InsertarRecursivo(x);
		    cout << "\nIntroduzca un entero (0 para fin): ";
		    cin >> x;
		    }
	  */
	  /* los instertamos para ganar tiempo */
	  a.InsertarRecursivo(10);
	  a.InsertarRecursivo(5);
	  a.InsertarRecursivo(20);	      
	  a.InsertarRecursivo(1);	      
	  a.InsertarRecursivo(6);	      
	  a.InsertarRecursivo(18);	      
	  a.InsertarRecursivo(25);	      
	  
	  pausa();
	  break;
	case 2: // Buscar un nodo
	  cout << "\nIntroduzca el numero a buscar " << endl;
	  cin >> x;
	  encontrado=a.BuscarRecursivo(x);
	  if(encontrado==0)
	    {
	      cout << "\nNo Existe el elemento a buscar" << endl;
	    }
	  else
	    {
	      cout << "\nEl elemento " << x << " existe" << endl;
	    }
	  pausa();
	  break;
	case 3: // Recorrido prefijo
	  cout << "\nRecorrido Prefijo\n" << endl;
	  a.RecorridoPrefijo(imprime);
	  pausa();
	  break;
	case 4: // Recorrido infijo
	  cout << "\nRecorrido Infijo\n" << endl;
	  a.RecorridoInfijo(imprime);
	  pausa();
	  break;
	case 5: // Recorrido postfijo
	  cout << "\nRecorrido Postfijo\n" << endl;
	  a.RecorridoPostfijo(imprime);
	  pausa();
	  break;
	case 6: // Minimo
	  cout << "\nMinimo del Arbol\n" << endl;
	  a.BuscarMinimo(imprime);
	  pausa();
	  break;
	case 7: // Maximo
	  cout << "\nMaximo del Arbol\n" << endl;
	  a.BuscarMaximo(imprime);
	  pausa();
	  break;
	case 8: // Altura de un nodo
	  cout << "\nDime el valor del nodo: ";
	  cin >> valor;
	  a.Altura(valor,contador);
	  if (contador)
	    {
	      cout << "\n\nEl nodo tiene una altura de " << contador-1 << endl;
	    }
	  else
	    {
	      cout << "\n\nEse nodo no existe\n\n";
	    }
	  contador=0;
	  pausa();
	  break;
	case 9: // Profundidad de un nodo
	  cout << "\nDime el valor del nodo: ";
	  cin >> valor;
	  a.Profundidad(valor,contador);
	  if (contador)
	    {
	      cout << "\n\nEl nodo tiene una profundidad de " << contador;
	    }
	  else
	    {
	      cout << "\n\nEse nodo no existe\n\n";
	    }
	  contador=0;
	  pausa();
	  break;
	  
	case 10: // Descendientes de un nodo dado
	  cout << "\nDime el valor del nodo: " ;
	  cin >> valor;
	  a.Descendientes(valor,contador);
	  if (contador) // diferente de cero
	    {
	      cout << "\n\nEl nodo tiene " << contador-1 << " descendientes\n";
	    }
	  else // si es cero
	    {
	      cout << "\n\nEse nodo no existe\n\n";
	    }
	  contador=0;
	  pausa();
	  break;
	case 11: // Descendientes de un nodo dado
	  cout << "\nDime el valor del nodo: " ;
	  cin >> valor;
	  a.Descendientes_Hojas(valor,contador);
	  if (contador) // diferente de cero
	    {
	      cout << "\n\nEl nodo tiene " << contador-1 << " descendientes que son hojas\n";
	    }
	  else // si es cero
	    {
	      cout << "\n\nEse nodo no existe\n\n";
	    }
	  contador=0;
	  pausa();
	  break;

	case 12: // Abuelo
	  cout << "\nDime el valor del nodo; " ;
	  cin >> valor;
	  a.Abuelo(valor);
	  pausa();
	  break;
	case 13: // Padre
	  cout << "\nDime el valor del nodo; " ;
	  cin >> valor;
	  a.Padre(valor);
	  pausa();
	  break;
	case 14: // Terminales
	  a.Terminales();
	  pausa();
	  break;
	case 15: // actualizar
	  a.Actualizar();
	  pausa();
	  break;
	case 16: // media de los nodos
	  cout << "La media es :" << a.Media() << endl;
	  pausa();
	  break;

	case 0:
	  a.Liberar();
          exit(0);
	  
	}
    }while(opcion); 
  
  
  // a.Recorrido(imprime);
  /* a.descendientes(x); */ 
  
}
