#include "grafo.h"
// #include "arbol.h"

void imprime(int x)
{
  cout << x << ", ";
}



void main(void)
{
	grafo a;
	arbol tree;
	int n,opcion, x;
	int origen, destino;
	double distancia;
	cout << "\nDime el n de nodos del grafo: ";
	cin >> n;
	if (a.reservar (n)==-1)
	{
		cout << "\nError en la asignacion de memoria\n";
		exit(1);
	}
   	do
   	{
		system ("clear");
     		cout << "\nMenu de Opciones\n";
		cout << " 1.- Introducir matriz de conectividad\n";
		cout << " 2.- Introducir nodos en el grafo\n";
		cout << " 3.- Borrar nodos del grafo\n";
      		cout << " 4.- Algoritmo de Dijkstra\n";
      		cout << " 5.- Algoritmo de Floyd\n";
      		cout << " 6.- Recorrido en profundidad\n";
		cout << " 7.- Visualizar matriz de conectividad\n";
		cout << " 8.- Componentes conexas de un grafo\n";
		cout << " 9.- Caminos minimos entre todos los nodos (Dijsktra)\n";
		cout << "10.- Busqueda de ciclos de un grafo\n";
		cout << "11.- Prim\n";
		cout << "12.- Kruskal\n";
		cout << "13.- Grafo Abarcador de Recorrido Maximo\n";
		cout << "14.- Mostrar\n";
		cout << "15.- Warshall\n";
		cout << "16.- Camino mas corto dado dos nudos origen y destino\n";
		cout << " 0.- Salir\n";
		cout << "\n\tElija una opcion: ";
		cin >> opcion;
		switch (opcion)
		{
			case 1:	cout << "\n\n";
				a.introducir();
				break;
			case 2: system ("clear");
				if (a.nuevo_nodo()==-1)
				{
					cout << "\nError en la asignacion de memoria\n";
					break;
				}
				cout << "\nIntroduce las conecciones del nuevo nodo\n\n";
				a.nuevas_conexiones();				
				break;
			case 3: system ("clear");
				cout << "\nBorrado de nodos\n\n";
				cout << "\nDime el nodo a borrar: ";
				cin >> n;
				if (a.borrar(n)==-1)
					cout << "\nError en el borrado o nodo no se encuentra\n";
				break;
			case 4: cout << "\nAlgoritmo de Dijkstra\n\n";
				if (a.dijkstra()==-1)
					cout << "\nSe ha producido un error\n";
		cout << "\n\nPulsa una tecla .... ";
		getchar();
				break;
			case 5: cout << "\nAlgoritmo de Floyd\n\n";
				if (a.floyd()==-1)
					cout << "\nSe ha producido un error\n";
		cout << "\n\nPulsa una tecla .... ";
		getchar();
				break;
	 		case 6: system ("clear");
				cout << "\nRecorrido en profundidad\n";
				if (a.profundidad()==-1)
					cout << "\nSe ha producido un error\n";
		cout << "\n\nPulsa una tecla .... ";
		getchar();
				break;
			case 7: system ("clear");
				cout << "\nMatriz de conectividad\n\n";
				a.visualizar();
		cout << "\n\nPulsa una tecla .... ";
		getchar();
				break;
                        case 8: system ("clear");
                                cout << "\nComponentes conexas\n";
                                if ((n=a.componentes())==-1)
                                        cout << "\nSe ha producido un error\n";
                                else
                                        cout << "\n\nHay " << n << " componentes conexas";
		cout << "\n\nPulsa una tecla .... ";
		getchar();
				break;
			case 9: cout << "\nCaminos minimos entre todos los pares de nodos\n\n";
				if (a.cmtpn_dijkstra()==-1)
					cout << "\nSe ha producido un error\n";
		cout << "\n\nPulsa una tecla .... ";
		getchar();
				break;
			case 10:system ("clear");
				cout << "\nBusqueda de ciclos\n";
				if ((n=a.ciclos())==-1)
					cout << "\nSe ha producido un error\n";
				else
					if (n)
						cout << "\nHay ciclos\n";
					else
						cout << "\nNo hay ciclos\n";

		cout << "\n\nPulsa una tecla .... ";
		getchar();
				break;
			case 11:system ("clear");
			        a.prim();
		cout << "\n\nPulsa una tecla .... ";
		getchar();
			        break;
			case 12:system ("clear");
			        a.kruskal();
		cout << "\n\nPulsa una tecla .... ";
		getchar();
			        break;
			case 13:system ("clear");
			        a.aarm();
		cout << "\n\nPulsa una tecla .... ";
		getchar();
			        break;
			case 14:system ("clear");
			        cout << "\nIntroduzca el valor del nodo:\n";
			        cin >> x;
			        a.mostrar(x);
			        break;
		cout << "\n\nPulsa una tecla .... ";
		getchar();
			case 15:system ("clear");
			        a.warshall();
		cout << "\n\nPulsa una tecla .... ";
		getchar();
			        break;
		cout << "\n\nPulsa una tecla .... ";
		getchar();

			case 16:system ("clear");
//			        cout << "El camino mas corto desde " << origen;
			    //    cout << a.dijkstra2(origen,destino);
		cout << "\n\nPulsa una tecla .... ";
		getchar();
			        break;
			case 17:system ("clear");
			        a.aarm2(tree);
				cout << "\nRecorrido Infijo del arbol" endl;
				tree.RecorridoInfijo(imprime);
		cout << "\n\nPulsa una tecla .... ";
		getchar();
			        break;

		cout << "\n\nPulsa una tecla .... ";
		getchar();

			case 0: exit(0);
				break;
		}

		cout << "\n\nPulsa una tecla .... ";
		getchar();
	} while (opcion);
}


