#include "arbol.h"

// funcion que calcula la media de un arbol.
float arbol::Media()
{
float mitad, items;

  if (raiz!=NULL)
    {
    mitad = (float)raiz->suma_elementos(raiz);
    items = (float)raiz->elementos(raiz);
    mitad = mitad / items;
    return mitad;
    }
else	
    {
    return 0;
    }
}

// Calcula de manera recursiva la suma de los elementos de un arbol
// se le pasa el nodo raiz.
int arbol::nudo::suma_elementos(nudo *p)
{
int items=0;
      if(p!=NULL)
          {
	  items=items+p->inf;
	  if(p->hi!=NULL)
	      {
	      items=items+suma_elementos(p->hi);
	      }
	  if(p->hd!=NULL)
	      {
	      items=items+suma_elementos(p->hd);
	      }
	  }
return items;
}

// cuenta los elementos de un arbol de manera recursiva,
// se le pasa el nodo raiz
int arbol::nudo::elementos(nudo *p)
{
int items=0;
      if(p!=NULL)
          {
	  items++;
	  if(p->hi!=NULL)
	      {
	      items=items+elementos(p->hi);
	      }
	  if(p->hd!=NULL)
	      {
	      items=items+elementos(p->hd);
	      }
	  }
return items;
}

int arbol::nudo::elemento_n(nudo *p, int valor)
{
int items=0;
      if(p!=NULL)
          {
	  items++;
	  if(items==valor)
	      {
	      cout << inf << endl;
	      }
	  else{
	  if(p->hi!=NULL)
	      {
	      items=items+elementos(p->hi,valor);
	      }
	  if(p->hd!=NULL)
	      {
	      items=items+elementos(p->hd,valor);
	      }
	      }
	  }
return items;
}

