#include "grafo.h"

int grafo::warshall(void)
{
  return warshall (m,nodos,orden);
}


int grafo::warshall(double **m,int *nodos,int orden)
{
  double **a,**p;
  int i,j,k;

  /* Matriz auxiliar con la que vamos a trabajar, que pasa a ser la matriz
  de conexion */
  if (reservar_matriz(a,orden)==-1)
    {
      return -1;
    }
  
  for (i=0;i<orden;i++)
    {
      for (j=0;j<orden;j++)
	{
//	a[i][j]=m[i][j];
	  // almacenamos la matriz logica de conexion
	  if(m[i][j]==INFINITO)
	    {
	      a[i][j]=0; // no hay conexion
	    }
	  else
	    {
	      a[i][j]=1; // si hay conexion
	    }
	    
	}
    }
  // esto para que los nudos no esten unidos consigo mismos, bucles
  
  for (i=0;i<orden;i++)
    {
      for (j=0;j<orden;j++)
	{
	  if(i==j)
          {
	    a[i][j]=0;
	  }
	}
    }    
  
  
  for (k=0;k<orden;k++)
    {
      for (i=0;i<orden;i++)
      {
        for (j=0;j<orden;j++)
          {
            /* Actualizamos la matriz si la distancia a */
            /* traves del nodo intermedio es menor */
            if (a[i][j]==0 && i!=j)
              {
                a[i][j]=a[i][k]*a[k][j];
		
              }
          }
      }
    }
    
// mostramos por pantalla los valores.
  cout << "\n\nCerradura transitiva de la matriz conexion es:\n";
  for (i=0;i<orden;i++)
    {
      cout << "\n";
      for (j=0;j<orden;j++)
        {
          if (a[i][j]==0)
            {
              cout << 0 << "\t";
            }
          else
            {
              cout << a[i][j] << "\t";
            }
        }
    }
}

