#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include "arbol.h"

#define INFINITO 1000000

typedef struct lado
{
double c;
int n1;
int n2;
} LADO;

class grafo
{
	double **m;
	int *nodos;
	int orden;
	int reservar (double ** &m,int * &nodos,int n);
	void introducir(double ** &m,int * &nodos,int orden);
	int nuevo_nodo (double ** &m,int * &nodos,int &orden);
	void nuevas_conexiones(double ** &m,int * &nodos,int orden);
	int borrar (double ** &m,int * &nodos,int &orden,int nodo);
	int dijkstra (double **m,int *nodos,int orden);
	double dijkstra2 (double **m,int *nodos,int orden, int origen, int destino);
	void camino_dijkstra(double *p,int *nodos,double i);
	int floyd (double **m,int *nodos,int orden);
	int warshall (double **m,int *nodos,int orden);
	void camino_floyd(double **p,int *nodos,double i,double j);
	int profundidad (double **m,int *nodos,int orden);
	void bp(double **m,int *nodos,int orden,int * &v,int i);
	int componentes(double **m, int *nodos,int orden);
	int cmtpn_dijkstra (double **m,int orden);
	int ciclos (double **m,int *nodos,int orden);
	void busqueda_ciclos(double **m,int *nodos,int orden,int * &v,int i,int * &aux,int &sw);
	void visualizar (double **m,int *nodos,int orden);
	void mostrar (double **m,int *nodos,int orden,int x);
	void liberar (double ** &m,int * &nodos,int orden);
	int prim(double **m, int *nodos, int orden);
	int kruskal(double **m, int *nodos, int orden);
        void unir (LADO * &l,int *conj,int orden,int k);
        void ordenar (LADO * &l,int k);
	int aarm (double **m,int *nodos,int orden);
	int aarm2 (double **m,int *nodos,int orden,arbol &tree);
 
	
    public:
	int reservar (int n);
	void introducir(void);
	int nuevo_nodo (void);
	void nuevas_conexiones(void);
	int borrar(int nodo);
	int dijkstra(void);
	double dijkstra2(int origen,int destino);
	int floyd(void);
	int warshall(void);
	int prim(void);
	int kruskal(void);
	int aarm(void);
	int aarm2(arbol &tree);
	int profundidad(void);
	int componentes(void);
	int cmtpn_dijkstra (void);
	int ciclos(void);
	void visualizar (void);
	void mostrar(int x);
	~grafo (void);
};

int reservar_matriz(double ** &m, int n);

